/* -*- c++ -*-
*
* SOCLIB_LGPL_HEADER_BEGIN
*
* This file is part of SoCLib, GNU LGPLv2.1.
*
* SoCLib is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; version 2.1 of the License.
*
* SoCLib is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the cabaied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with SoCLib; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301 USA
*
* SOCLIB_LGPL_HEADER_END
*
* Copyright (c) Lab-sticc, file generated by GAUT(Version 2.4.2 December 2009)
*
*
*/
#include <stdlib.h>
#include "base_module.h"
#include "../include/vci_v.h"

namespace soclib { namespace caba {

#define tmpl(x) template <typename vci_param> x Vci_v<vci_param>

/* Constructor */
tmpl(/**/)::Vci_v(sc_module_name insname,
	const soclib::common::MappingTable &mt,
	const soclib::common::IntTab &t_index)
	:soclib::caba::BaseModule(insname),
	m_fifo_in_1("fifo_in_1",1),
	m_fifo_out_1("fifo_out_1",1),
	m_fifo_out_2("fifo_out_2",1),
	m_fifo_out_3("fifo_out_3",1),
	m_segment(mt.getSegment(t_index)),
	p_clk("clk"),
	p_resetn("resetn"),
	p_t_vci("t_vci"),
	m_vci_fsm(p_t_vci, mt.getSegmentList(t_index),1)
{
	SC_METHOD(transition);
	dont_initialize();
	sensitive << p_clk.pos();
	SC_METHOD(genMoore);
	dont_initialize();
	sensitive << p_clk.neg();
	m_vci_fsm.on_read_write(on_read, on_write);
	r_status.done = false;
	r_status.output_available = false;
	m_state_cycle = S0;
	m_wait_IO = false;
	/* constant */
	m_a1 = 0;
	m_a11 = 0;
	m_a113 = 0;
	m_a12 = 0;
	m_a123 = 0;
	m_a13 = 0;
	m_a2 = 0;
	m_a22 = 0;
	m_a221 = 0;
	m_a223 = 0;
	m_a3 = 0;
	m_a33 = 0;
	m_a331 = 0;
	m_a332 = 0;
}


/* Read interface vci */
tmpl(bool)::on_read(int seg,
	typename vci_param::addr_t addr,
	typename vci_param::data_t & data)
{
	int cell = (int)addr / vci_param::B;
	bool nerror = false;
	switch ((enum Vci_vRegisters)cell)
	{
		case OUT_DATA_1:
			if(m_fifo_out_1.rok())
			{
				data=m_fifo_out_1.read();
				m_fifo_out_1.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_2:
			if(m_fifo_out_2.rok())
			{
				data=m_fifo_out_2.read();
				m_fifo_out_2.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_3:
			if(m_fifo_out_3.rok())
			{
				data=m_fifo_out_3.read();
				m_fifo_out_3.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case STATUS:
		{
			int local_data=0;
			local_data=r_status.done+((unsigned int)r_status.output_available << 8);
			data = local_data;
			/* reset flag after status register read */
			if ((r_status.done) || (r_status.output_available))
			{
				r_status.done=false;
				r_status.output_available=false;
			}
			nerror = true;
		}
		break;
		default :
		break;
	}
	return nerror;
}

/* Write interface vci */
tmpl(bool)::on_write(int seg,
	typename vci_param::addr_t addr,
	typename vci_param::data_t data,
	int be)
{	int cell = (int)addr / vci_param::B;
	bool nerror = false;
	switch ((enum Vci_vRegisters)cell)
	{
		case IN_DATA_1:
			if(m_fifo_in_1.wok())
			{
				m_fifo_in_1.simple_put(data);
				nerror = true;
			}
			else nerror = false;
		break;
		default :
		break;
	}
	return nerror;
}


/* predefined or user defined  operation */

/* Transition function */
/* Evaluated on Positive Clock Edge */
tmpl(void)::transition()
{
	if (p_resetn == false)
	{
		m_vci_fsm.reset();
		r_status.done = false;
		r_status.output_available = false;
		m_state_cycle = S0;
		m_wait_IO = false;
		/* variable */
		m_v_1721 = 0;
		m_v_1722 = 0;
		m_v_1724 = 0;
		m_v_1725 = 0;
		m_v_1727 = 0;
		m_v_1728 = 0;
		m_v_1729 = 0;
		m_v_1730 = 0;
		m_v_1731 = 0;
		m_aux1 = 0;
		m_aux11 = 0;
		m_aux12 = 0;
		m_aux2 = 0;
		m_aux21 = 0;
		m_aux22 = 0;
		m_aux3 = 0;
		m_aux31 = 0;
		m_aux32 = 0;
		m_aux4 = 0;
		m_aux41 = 0;
		m_aux42 = 0;
		m_auxa = 0;
		m_auxb = 0;
		m_tmp1 = 0;
		m_tmp11 = 0;
		m_tmp113 = 0;
		m_tmp12 = 0;
		m_tmp123 = 0;
		m_tmp13 = 0;
		m_tmp2 = 0;
		m_tmp22 = 0;
		m_tmp221 = 0;
		m_tmp223 = 0;
		m_tmp3 = 0;
		m_tmp33 = 0;
		m_tmp331 = 0;
		m_tmp332 = 0;
		m_tmpx12 = 0;
		m_tmpx22 = 0;
		m_tmpx32 = 0;
		m_xLPAREN1RPAREN = 0;
		m_xLPAREN2RPAREN = 0;
		m_xLPAREN3RPAREN = 0;
		/* output */
		m_test1 = 0;
		m_test2 = 0;
		m_test3 = 0;
		m_test4 = 0;
		m_test5 = 0;
		m_test6 = 0;
		m_yout = 0;
		return;
	}
	m_vci_fsm.transition();
	switch (m_state_cycle) {
		case S0:
			m_state_cycle=S1;
		break;
		case S1:
			m_state_cycle=S2;
		break;
		case S2:
			m_state_cycle=S3;
		break;
		case S3:
			m_tmp1 = m_a1 * m_xLPAREN1RPAREN;
			m_tmp2 = m_a2 * m_xLPAREN2RPAREN;
			m_tmp3 = m_a3 * m_xLPAREN3RPAREN;
			m_tmpx12 = m_xLPAREN1RPAREN * m_xLPAREN1RPAREN;
			m_state_cycle=S4;
		break;
		case S4:
			m_test1 = m_tmp1;
			m_test2 = m_tmp2;
			m_aux11 = m_tmp2 + m_tmp1;
			m_test3 = m_tmp3;
			if (m_fifo_out_1.wok()
			&& m_fifo_out_1.wok()
			&& m_fifo_out_2.wok())
			{
				m_fifo_out_1.simple_put(m_test1.to_int());
				m_fifo_out_1.simple_put(m_test2.to_int());
				m_fifo_out_2.simple_put(m_test3.to_int());
				r_status.output_available = true;
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S5;
		break;
		case S5:
			m_tmpx32 = m_xLPAREN3RPAREN * m_xLPAREN3RPAREN;
			m_tmp11 = m_tmpx12 * m_a11;
			m_v_1721 = m_a12 * m_xLPAREN1RPAREN;
			m_aux12 = m_aux11 + m_tmp3;
			m_tmpx22 = m_xLPAREN2RPAREN * m_xLPAREN2RPAREN;
			m_state_cycle=S6;
		break;
		case S6:
			m_aux1 = m_aux12 + m_tmp3;
			m_state_cycle=S7;
		break;
		case S7:
			m_tmp22 = m_tmpx22 * m_a22;
			m_tmp33 = m_tmpx32 * m_a33;
			m_tmp12 = m_v_1721 * m_xLPAREN2RPAREN;
			m_v_1722 = m_a13 * m_xLPAREN1RPAREN;
			m_aux22 = m_aux1 + m_tmp11;
			m_state_cycle=S8;
		break;
		case S8:
			m_aux2 = m_aux22 + m_tmp22;
			m_state_cycle=S9;
		break;
		case S9:
			m_tmp13 = m_v_1722 * m_xLPAREN3RPAREN;
			m_v_1727 = m_xLPAREN3RPAREN * m_a113;
			m_v_1728 = m_xLPAREN1RPAREN * m_a221;
			m_v_1729 = m_xLPAREN3RPAREN * m_a223;
			m_aux21 = m_aux2 + m_tmp33;
			m_state_cycle=S10;
		break;
		case S10:
			m_auxa = m_aux21 + m_tmp12;
			m_state_cycle=S11;
		break;
		case S11:
			m_v_1724 = m_a123 * m_xLPAREN1RPAREN;
			m_tmp113 = m_v_1727 * m_tmpx12;
			m_tmp221 = m_v_1728 * m_tmpx22;
			m_v_1730 = m_xLPAREN1RPAREN * m_a331;
			m_aux42 = m_auxa + m_tmp12;
			m_state_cycle=S12;
		break;
		case S12:
			m_aux4 = m_aux42 + m_tmp13;
			m_state_cycle=S13;
		break;
		case S13:
			m_v_1725 = m_v_1724 * m_xLPAREN2RPAREN;
			m_tmp223 = m_v_1729 * m_tmpx22;
			m_tmp331 = m_v_1730 * m_tmpx32;
			m_v_1731 = m_xLPAREN2RPAREN * m_a332;
			m_aux41 = m_aux4 + m_tmp113;
			m_state_cycle=S14;
		break;
		case S14:
			m_auxb = m_aux41 + m_tmp221;
			m_state_cycle=S15;
		break;
		case S15:
			m_test6 = m_tmpx32 * m_xLPAREN3RPAREN;
			m_tmp123 = m_v_1725 * m_xLPAREN3RPAREN;
			m_tmp332 = m_v_1731 * m_tmpx32;
			m_aux32 = m_auxb + m_tmp223;
			m_test4 = m_tmpx12 * m_xLPAREN1RPAREN;
			if (m_fifo_out_1.wok()
			&& m_fifo_out_1.wok())
			{
				m_fifo_out_1.simple_put(m_test4.to_int());
				m_fifo_out_1.simple_put(m_test6.to_int());
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S16;
		break;
		case S16:
			m_aux3 = m_aux32 + m_tmp331;
			m_state_cycle=S17;
		break;
		case S17:
			m_aux31 = m_aux3 + m_tmp332;
			m_test5 = m_tmpx22 * m_xLPAREN2RPAREN;
			if (m_fifo_out_1.wok())
			{
				m_fifo_out_1.simple_put(m_test5.to_int());
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S18;
		break;
		case S18:
			if (m_fifo_in_1.rok())
			{
				m_xin=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_yout = m_tmp123 + m_aux31;
			if (!m_wait_IO)
			{
				m_state_cycle=S0;
			m_xLPAREN3RPAREN = m_xLPAREN2RPAREN; // aging
			m_xLPAREN2RPAREN = m_xLPAREN1RPAREN; // aging
			m_xLPAREN1RPAREN = m_xin; // aging
				r_status.done = true;
			}
		break;
	}
}
/* Moore fsm generation */
/* Evaluated on Negative Clock Edge */
tmpl(void)::genMoore()
{
	m_vci_fsm.genMoore();
}
}}
