/* -*- c++ -*-
*
* SOCLIB_LGPL_HEADER_BEGIN
*
* This file is part of SoCLib, GNU LGPLv2.1.
*
* SoCLib is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; version 2.1 of the License.
*
* SoCLib is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the cabaied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with SoCLib; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301 USA
*
* SOCLIB_LGPL_HEADER_END
*
* Copyright (c) Lab-sticc, file generated by GAUT(Version 2.4.2 December 2009)
*
*
*/
#ifndef _SOCLIB_CABA_VCI_V_H_
#define _SOCLIB_CABA_VCI_V_H_
#include <stdio.h>
#include <systemc.h>
#include "caba_base_module.h"
#include "generic_fifo.h"
#include "vci_target.h"
#include "mapping_table.h"
#include "vci_target_fsm.h"

namespace soclib { namespace caba {

using namespace sc_core;

template<typename vci_param> class Vci_v
	: public  soclib::caba::BaseModule
{
public:
	sc_in<bool> p_clk;
	sc_in<bool> p_resetn;
	soclib::caba::VciTarget<vci_param> p_t_vci;
private:
	caba::VciTargetFsm<vci_param, true> m_vci_fsm;
	const soclib::common::Segment       m_segment;
	bool on_write(int seg,
		typename vci_param::addr_t addr,
		typename vci_param::data_t data,
		int be);
	bool on_read(int seg,
		typename vci_param::addr_t addr,
		typename vci_param::data_t &data);
	void transition();
	void genMoore();
	/* STRUCTURAL members */
	/* states of the GAUT FSMD */
	typedef enum {S0,S1,S2,S3,S4,S5,S6,S7,S8,
                      S9,S10,S11,S12,S13,S14,S15,S16,S17,S18} GAUT_FSM_t;
	struct Status {
		unsigned char done;
		unsigned char output_available;
	} r_status;
	soclib::caba::GenericFifo<int32_t> m_fifo_in_1;
	soclib::caba::GenericFifo<int32_t> m_fifo_out_1; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_2; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_3; 
	int32_t m_wait_IO;
	GAUT_FSM_t m_state_cycle;
	/* constant */
	sc_int<32> m_a1;
	sc_int<32> m_a11;
	sc_int<32> m_a113;
	sc_int<32> m_a12;
	sc_int<32> m_a123;
	sc_int<32> m_a13;
	sc_int<32> m_a2;
	sc_int<32> m_a22;
	sc_int<32> m_a221;
	sc_int<32> m_a223;
	sc_int<32> m_a3;
	sc_int<32> m_a33;
	sc_int<32> m_a331;
	sc_int<32> m_a332;
	/* input */
	sc_int<32> m_xin;
	/* output */
	sc_int<32> m_test1;
	sc_int<32> m_test2;
	sc_int<32> m_test3;
	sc_int<32> m_test4;
	sc_int<32> m_test5;
	sc_int<32> m_test6;
	sc_int<32> m_yout;
	/* variable */
	sc_int<32> m_v_1721;
	sc_int<32> m_v_1722;
	sc_int<32> m_v_1724;
	sc_int<32> m_v_1725;
	sc_int<32> m_v_1727;
	sc_int<32> m_v_1728;
	sc_int<32> m_v_1729;
	sc_int<32> m_v_1730;
	sc_int<32> m_v_1731;
	sc_int<32> m_aux1;
	sc_int<32> m_aux11;
	sc_int<32> m_aux12;
	sc_int<32> m_aux2;
	sc_int<32> m_aux21;
	sc_int<32> m_aux22;
	sc_int<32> m_aux3;
	sc_int<32> m_aux31;
	sc_int<32> m_aux32;
	sc_int<32> m_aux4;
	sc_int<32> m_aux41;
	sc_int<32> m_aux42;
	sc_int<32> m_auxa;
	sc_int<32> m_auxb;
	sc_int<32> m_tmp1;
	sc_int<32> m_tmp11;
	sc_int<32> m_tmp113;
	sc_int<32> m_tmp12;
	sc_int<32> m_tmp123;
	sc_int<32> m_tmp13;
	sc_int<32> m_tmp2;
	sc_int<32> m_tmp22;
	sc_int<32> m_tmp221;
	sc_int<32> m_tmp223;
	sc_int<32> m_tmp3;
	sc_int<32> m_tmp33;
	sc_int<32> m_tmp331;
	sc_int<32> m_tmp332;
	sc_int<32> m_tmpx12;
	sc_int<32> m_tmpx22;
	sc_int<32> m_tmpx32;
	sc_int<32> m_xLPAREN1RPAREN;
	sc_int<32> m_xLPAREN2RPAREN;
	sc_int<32> m_xLPAREN3RPAREN;
protected:
	SC_HAS_PROCESS(Vci_v);
public:
	Vci_v(sc_module_name insname,
		const soclib::common::MappingTable &mt,
		const soclib::common::IntTab &t_index
		);
	~Vci_v() {}
};//en class Vci_v
	enum Vci_vRegisters {
		STATUS,
		IN_DATA_1,
		OUT_DATA_1,
		OUT_DATA_2,
		OUT_DATA_3,
};
}}
#endif /* _SOCLIB_CABA_VCI_V_H_ */
