/* -*- c++ -*-
*
* SOCLIB_LGPL_HEADER_BEGIN
*
* This file is part of SoCLib, GNU LGPLv2.1.
*
* SoCLib is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; version 2.1 of the License.
*
* SoCLib is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the cabaied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with SoCLib; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301 USA
*
* SOCLIB_LGPL_HEADER_END
*
* Copyright (c) Lab-sticc, file generated by GAUT(Version 2.4.2 December 2009)
*
*
*/
#include <stdlib.h>
#include "base_module.h"
#include "../include/vci_vr.h"

namespace soclib { namespace caba {

#define tmpl(x) template <typename vci_param> x Vci_vr<vci_param>

/* Constructor */
tmpl(/**/)::Vci_vr(sc_module_name insname,
	const soclib::common::MappingTable &mt,
	const soclib::common::IntTab &t_index)
	:soclib::caba::BaseModule(insname),
	m_fifo_in_1("fifo_in_1",1),
	m_fifo_in_2("fifo_in_2",1),
	m_fifo_in_3("fifo_in_3",1),
	m_fifo_in_4("fifo_in_4",1),
	m_fifo_out_1("fifo_out_1",1),
	m_fifo_out_2("fifo_out_2",1),
	m_fifo_out_3("fifo_out_3",1),
	m_fifo_out_4("fifo_out_4",1),
	m_fifo_out_5("fifo_out_5",1),
	m_fifo_out_6("fifo_out_6",1),
	m_segment(mt.getSegment(t_index)),
	p_clk("clk"),
	p_resetn("resetn"),
	p_t_vci("t_vci"),
	m_vci_fsm(p_t_vci, mt.getSegmentList(t_index),1)
{
	SC_METHOD(transition);
	dont_initialize();
	sensitive << p_clk.pos();
	SC_METHOD(genMoore);
	dont_initialize();
	sensitive << p_clk.neg();
	m_vci_fsm.on_read_write(on_read, on_write);
	r_status.done = false;
	r_status.output_available = false;
	m_state_cycle = S0;
	m_wait_IO = false;
	/* constant */
	m_const_1 = 1;
	m_const_2 = 2;
	m_tmp_id3 = 0;
}


/* Read interface vci */
tmpl(bool)::on_read(int seg,
	typename vci_param::addr_t addr,
	typename vci_param::data_t & data)
{
	int cell = (int)addr / vci_param::B;
	bool nerror = false;
	switch ((enum Vci_vrRegisters)cell)
	{
		case OUT_DATA_1:
			if(m_fifo_out_1.rok())
			{
				data=m_fifo_out_1.read();
				m_fifo_out_1.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_2:
			if(m_fifo_out_2.rok())
			{
				data=m_fifo_out_2.read();
				m_fifo_out_2.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_3:
			if(m_fifo_out_3.rok())
			{
				data=m_fifo_out_3.read();
				m_fifo_out_3.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_4:
			if(m_fifo_out_4.rok())
			{
				data=m_fifo_out_4.read();
				m_fifo_out_4.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_5:
			if(m_fifo_out_5.rok())
			{
				data=m_fifo_out_5.read();
				m_fifo_out_5.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case OUT_DATA_6:
			if(m_fifo_out_6.rok())
			{
				data=m_fifo_out_6.read();
				m_fifo_out_6.simple_get();
				nerror = true;
			}
			else nerror = false;
		break;
		case STATUS:
		{
			int local_data=0;
			local_data=r_status.done+((unsigned int)r_status.output_available << 8);
			data = local_data;
			/* reset flag after status register read */
			if ((r_status.done) || (r_status.output_available))
			{
				r_status.done=false;
				r_status.output_available=false;
			}
			nerror = true;
		}
		break;
		default :
		break;
	}
	return nerror;
}

/* Write interface vci */
tmpl(bool)::on_write(int seg,
	typename vci_param::addr_t addr,
	typename vci_param::data_t data,
	int be)
{	int cell = (int)addr / vci_param::B;
	bool nerror = false;
	switch ((enum Vci_vrRegisters)cell)
	{
		case IN_DATA_1:
			if(m_fifo_in_1.wok())
			{
				m_fifo_in_1.simple_put(data);
				nerror = true;
			}
			else nerror = false;
		break;
		case IN_DATA_2:
			if(m_fifo_in_2.wok())
			{
				m_fifo_in_2.simple_put(data);
				nerror = true;
			}
			else nerror = false;
		break;
		case IN_DATA_3:
			if(m_fifo_in_3.wok())
			{
				m_fifo_in_3.simple_put(data);
				nerror = true;
			}
			else nerror = false;
		break;
		case IN_DATA_4:
			if(m_fifo_in_4.wok())
			{
				m_fifo_in_4.simple_put(data);
				nerror = true;
			}
			else nerror = false;
		break;
		default :
		break;
	}
	return nerror;
}


/* predefined or user defined  operation */

/* Transition function */
/* Evaluated on Positive Clock Edge */
tmpl(void)::transition()
{
	if (p_resetn == false)
	{
		m_vci_fsm.reset();
		r_status.done = false;
		r_status.output_available = false;
		m_state_cycle = S0;
		m_wait_IO = false;
		/* variable */
		m_tmp_id3_13 = 0;
		m_tmp_id49_15 = 0;
		m_tmp_id4_14 = 0;
		m_tmp_id112 = 0;
		m_tmp_id113 = 0;
		m_tmp_id114 = 0;
		m_tmp_id115 = 0;
		m_tmp_id116 = 0;
		m_tmp_id117 = 0;
		m_tmp_id118 = 0;
		m_tmp_id119 = 0;
		m_tmp_id120 = 0;
		m_tmp_id121 = 0;
		m_tmp_id122 = 0;
		m_tmp_id123 = 0;
		m_tmp_id23 = 0;
		m_tmp_id29 = 0;
		m_tmp_id32 = 0;
		m_tmp_id32000001 = 0;
		m_tmp_id34 = 0;
		m_tmp_id38 = 0;
		m_tmp_id38000001 = 0;
		m_tmp_id4 = 0;
		m_tmp_id4000001 = 0;
		m_tmp_id41 = 0;
		m_tmp_id43 = 0;
		m_tmp_id45 = 0;
		m_tmp_id45000001 = 0;
		m_tmp_id47 = 0;
		m_tmp_id49 = 0;
		m_tmp_id49000001 = 0;
		m_tmp_id51 = 0;
		m_tmp_id53 = 0;
		m_tmp_id53000001 = 0;
		m_tmp_id55 = 0;
		m_tmp_id58 = 0;
		m_tmp_id60 = 0;
		m_tmp_id60000001 = 0;
		m_tmp_id62 = 0;
		m_tmp_id67 = 0;
		m_tmp_id69 = 0;
		m_tmp_id69000001 = 0;
		m_tmp_id72 = 0;
		m_tmp_id88 = 0;
		m_tmp_tmp1 = 0;
		m_tmp_tmp2 = 0;
		m_tmp_tmp3 = 0;
		/* output */
		m_test1 = 0;
		m_test2 = 0;
		m_test3 = 0;
		m_test4 = 0;
		m_test5 = 0;
		m_test6 = 0;
		m_yout = 0;
		return;
	}
	m_vci_fsm.transition();
	switch (m_state_cycle) {
		case S0:
			if (m_fifo_in_1.rok()
			&& m_fifo_in_1.rok()
			&& m_fifo_in_2.rok()
			&& m_fifo_in_3.rok())
			{
				m_xin=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a1=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a2=m_fifo_in_2.read();
				m_fifo_in_2.simple_get();
				m_a3=m_fifo_in_3.read();
				m_fifo_in_3.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S1;
		break;
		case S1:
			m_state_cycle=S2;
		break;
		case S2:
			if (m_fifo_in_1.rok()
			&& m_fifo_in_1.rok()
			&& m_fifo_in_2.rok())
			{
				m_a221=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a223=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a11=m_fifo_in_2.read();
				m_fifo_in_2.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_tmp_tmp1 = m_xin * m_a1;
			m_tmp_tmp2 = m_a2 * m_xin;
			m_tmp_tmp3 = m_a3 * m_xin;
			m_test4 = m_tmp_id4;
			m_test5 = m_tmp_id4;
			m_test6 = m_tmp_id4;
			if (!m_wait_IO) m_state_cycle=S3;
		break;
		case S3:
			m_tmp_id88 = m_tmp_id38 << m_const_1;
			m_tmp_id118 = m_tmp_tmp2 + m_tmp_tmp1;
			m_test1 = m_tmp_tmp1;
			m_test2 = m_tmp_tmp2;
			m_test3 = m_tmp_tmp3;
			if (m_fifo_out_3.wok()
			&& m_fifo_out_4.wok()
			&& m_fifo_out_5.wok())
			{
				m_fifo_out_3.simple_put(m_test1.to_int());
				m_fifo_out_4.simple_put(m_test2.to_int());
				m_fifo_out_5.simple_put(m_test3.to_int());
				r_status.output_available = true;
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S4;
		break;
		case S4:
			if (m_fifo_in_1.rok()
			&& m_fifo_in_1.rok()
			&& m_fifo_in_2.rok())
			{
				m_a113=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a33=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a13=m_fifo_in_2.read();
				m_fifo_in_2.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_tmp_id72 = m_a223 * m_tmp_id69;
			m_tmp_id23 = m_a11 * m_tmp_id3;
			m_tmp_id51 = m_a221 * m_tmp_id49;
			if (!m_wait_IO) m_state_cycle=S5;
		break;
		case S5:
			m_tmp_id29 = m_tmp_tmp3 << m_const_1;
			m_tmp_id116 = m_tmp_id118 + m_tmp_id51;
			m_state_cycle=S6;
		break;
		case S6:
			if (m_fifo_in_1.rok()
			&& m_fifo_in_1.rok())
			{
				m_a12=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a22=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_tmp_id55 = m_a113 * m_tmp_id53;
			m_tmp_id58 = m_a33 * m_tmp_id3;
			m_tmp_id62 = m_a13 * m_tmp_id60;
			m_tmp_id119 = m_tmp_id116 + m_tmp_id29;
			if (!m_wait_IO) m_state_cycle=S7;
		break;
		case S7:
			m_tmp_id115 = m_tmp_id119 + m_tmp_id72;
			m_state_cycle=S8;
		break;
		case S8:
			if (m_fifo_in_1.rok()
			&& m_fifo_in_1.rok())
			{
				m_a331=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_a123=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_tmp_id41 = m_tmp_id88 * m_a12;
			m_tmp_id43 = m_a22 * m_tmp_id3;
			m_tmp_id3_13 = m_xin * m_xin;
			m_tmp_id112 = m_tmp_id115 + m_tmp_id23;
			if (!m_wait_IO) m_state_cycle=S9;
		break;
		case S9:
			m_tmp_id60000001 = m_tmp_id3_13;
			m_tmp_id38000001 = m_tmp_id3_13;
			m_tmp_id113 = m_tmp_id112 + m_tmp_id55;
			m_state_cycle=S10;
		break;
		case S10:
			if (m_fifo_in_1.rok())
			{
				m_a332=m_fifo_in_1.read();
				m_fifo_in_1.simple_get();
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			m_tmp_id34 = m_a331 * m_tmp_id32;
			m_tmp_id47 = m_a123 * m_tmp_id45;
			m_tmp_id122 = m_tmp_id113 + m_tmp_id58;
			m_tmp_id49_15 = m_xin * m_tmp_id3;
			if (!m_wait_IO) m_state_cycle=S11;
		break;
		case S11:
			m_tmp_id32000001 = m_tmp_id49_15;
			m_tmp_id121 = m_tmp_id122 + m_tmp_id62;
			m_tmp_id49000001 = m_tmp_id49_15;
			m_state_cycle=S12;
		break;
		case S12:
			m_tmp_id45000001 = m_xin * m_tmp_id38;
			m_tmp_id67 = m_a332 * m_tmp_id49;
			m_tmp_id123 = m_tmp_id121 + m_tmp_id41;
			m_tmp_id4_14 = m_tmp_id3_13 * m_xin;
			m_state_cycle=S13;
		break;
		case S13:
			m_tmp_id53000001 = m_tmp_id4_14;
			m_tmp_id120 = m_tmp_id123 + m_tmp_id43;
			m_tmp_id4000001 = m_tmp_id4_14;
			m_tmp_id69000001 = m_tmp_id4_14;
			m_state_cycle=S14;
		break;
		case S14:
			m_tmp_id114 = m_tmp_id120 + m_tmp_id34;
			m_state_cycle=S15;
		break;
		case S15:
			m_tmp_id117 = m_tmp_id114 + m_tmp_id47;
			m_state_cycle=S16;
		break;
		case S16:
			m_yout = m_tmp_id117 + m_tmp_id67;
			if (m_fifo_out_1.wok())
			{
				m_fifo_out_1.simple_put(m_yout.to_int());
				m_wait_IO = false;
			}
			else m_wait_IO = true;
			if (!m_wait_IO) m_state_cycle=S17;
		break;
		case S17:
			m_state_cycle=S18;
		break;
		case S18:
			m_state_cycle=S0;
			m_tmp_id32 = m_tmp_id32000001; //loopback
			m_tmp_id38 = m_tmp_id38000001; //loopback
			m_tmp_id4 = m_tmp_id4000001; //loopback
			m_tmp_id45 = m_tmp_id45000001; //loopback
			m_tmp_id49 = m_tmp_id49000001; //loopback
			m_tmp_id53 = m_tmp_id53000001; //loopback
			m_tmp_id60 = m_tmp_id60000001; //loopback
			m_tmp_id69 = m_tmp_id69000001; //loopback
			r_status.done = true;
		break;
	}
}
/* Moore fsm generation */
/* Evaluated on Negative Clock Edge */
tmpl(void)::genMoore()
{
	m_vci_fsm.genMoore();
}
}}
