/* -*- c++ -*-
*
* SOCLIB_LGPL_HEADER_BEGIN
*
* This file is part of SoCLib, GNU LGPLv2.1.
*
* SoCLib is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; version 2.1 of the License.
*
* SoCLib is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the cabaied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with SoCLib; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301 USA
*
* SOCLIB_LGPL_HEADER_END
*
* Copyright (c) Lab-sticc, file generated by GAUT(Version 2.4.2 December 2009)
*
*
*/
#ifndef _SOCLIB_CABA_VCI_VR_H_
#define _SOCLIB_CABA_VCI_VR_H_
#include <stdio.h>
#include <systemc.h>
#include "caba_base_module.h"
#include "generic_fifo.h"
#include "vci_target.h"
#include "mapping_table.h"
#include "vci_target_fsm.h"

namespace soclib { namespace caba {

using namespace sc_core;

template<typename vci_param> class Vci_vr
	: public  soclib::caba::BaseModule
{
public:
	sc_in<bool> p_clk;
	sc_in<bool> p_resetn;
	soclib::caba::VciTarget<vci_param> p_t_vci;
private:
	caba::VciTargetFsm<vci_param, true> m_vci_fsm;
	const soclib::common::Segment       m_segment;
	bool on_write(int seg,
		typename vci_param::addr_t addr,
		typename vci_param::data_t data,
		int be);
	bool on_read(int seg,
		typename vci_param::addr_t addr,
		typename vci_param::data_t &data);
	void transition();
	void genMoore();
	/* STRUCTURAL members */
	/* states of the GAUT FSMD */
	typedef enum {S0,S1,S2,S3,S4,S5,S6,S7,S8,
                      S9,S10,S11,S12,S13,S14,S15,S16,S17,S18} GAUT_FSM_t;
	struct Status {
		unsigned char done;
		unsigned char output_available;
	} r_status;
	soclib::caba::GenericFifo<int32_t> m_fifo_in_1;
	soclib::caba::GenericFifo<int32_t> m_fifo_in_2;
	soclib::caba::GenericFifo<int32_t> m_fifo_in_3;
	soclib::caba::GenericFifo<int32_t> m_fifo_in_4;
	soclib::caba::GenericFifo<int32_t> m_fifo_out_1; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_2; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_3; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_4; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_5; 
	soclib::caba::GenericFifo<int32_t> m_fifo_out_6; 
	int32_t m_wait_IO;
	GAUT_FSM_t m_state_cycle;
	/* constant */
	sc_uint<1> m_const_1;
	sc_int<32> m_const_2;
	sc_int<32> m_tmp_id3;
	/* input */
	sc_int<32> m_a1;
	sc_int<32> m_a11;
	sc_int<32> m_a113;
	sc_int<32> m_a12;
	sc_int<32> m_a123;
	sc_int<32> m_a13;
	sc_int<32> m_a2;
	sc_int<32> m_a22;
	sc_int<32> m_a221;
	sc_int<32> m_a223;
	sc_int<32> m_a3;
	sc_int<32> m_a33;
	sc_int<32> m_a331;
	sc_int<32> m_a332;
	sc_int<32> m_xin;
	/* output */
	sc_int<32> m_test1;
	sc_int<32> m_test2;
	sc_int<32> m_test3;
	sc_int<32> m_test4;
	sc_int<32> m_test5;
	sc_int<32> m_test6;
	sc_int<32> m_yout;
	/* variable */
	sc_int<32> m_tmp_id3_13;
	sc_int<32> m_tmp_id49_15;
	sc_int<32> m_tmp_id4_14;
	sc_int<32> m_tmp_id112;
	sc_int<32> m_tmp_id113;
	sc_int<32> m_tmp_id114;
	sc_int<32> m_tmp_id115;
	sc_int<32> m_tmp_id116;
	sc_int<32> m_tmp_id117;
	sc_int<32> m_tmp_id118;
	sc_int<32> m_tmp_id119;
	sc_int<32> m_tmp_id120;
	sc_int<32> m_tmp_id121;
	sc_int<32> m_tmp_id122;
	sc_int<32> m_tmp_id123;
	sc_int<32> m_tmp_id23;
	sc_int<32> m_tmp_id29;
	sc_int<32> m_tmp_id32;
	sc_int<32> m_tmp_id32000001;
	sc_int<32> m_tmp_id34;
	sc_int<32> m_tmp_id38;
	sc_int<32> m_tmp_id38000001;
	sc_int<32> m_tmp_id4;
	sc_int<32> m_tmp_id4000001;
	sc_int<32> m_tmp_id41;
	sc_int<32> m_tmp_id43;
	sc_int<32> m_tmp_id45;
	sc_int<32> m_tmp_id45000001;
	sc_int<32> m_tmp_id47;
	sc_int<32> m_tmp_id49;
	sc_int<32> m_tmp_id49000001;
	sc_int<32> m_tmp_id51;
	sc_int<32> m_tmp_id53;
	sc_int<32> m_tmp_id53000001;
	sc_int<32> m_tmp_id55;
	sc_int<32> m_tmp_id58;
	sc_int<32> m_tmp_id60;
	sc_int<32> m_tmp_id60000001;
	sc_int<32> m_tmp_id62;
	sc_int<32> m_tmp_id67;
	sc_int<32> m_tmp_id69;
	sc_int<32> m_tmp_id69000001;
	sc_int<32> m_tmp_id72;
	sc_int<32> m_tmp_id88;
	sc_int<32> m_tmp_tmp1;
	sc_int<32> m_tmp_tmp2;
	sc_int<32> m_tmp_tmp3;
protected:
	SC_HAS_PROCESS(Vci_vr);
public:
	Vci_vr(sc_module_name insname,
		const soclib::common::MappingTable &mt,
		const soclib::common::IntTab &t_index
		);
	~Vci_vr() {}
};//en class Vci_vr
	enum Vci_vrRegisters {
		STATUS,
		IN_DATA_1,
		IN_DATA_2,
		IN_DATA_3,
		IN_DATA_4,
		OUT_DATA_1,
		OUT_DATA_2,
		OUT_DATA_3,
		OUT_DATA_4,
		OUT_DATA_5,
		OUT_DATA_6,
};
}}
#endif /* _SOCLIB_CABA_VCI_VR_H_ */
