/*
 * =====================================================================================
 *
 *       Filename:  ConvertDfg2Ted.h
 *    Description:
 *        Created:  01/11/2010 02:26:33 PM
 *         Author:  Daniel F. Gomez-Prado (dgomezpr), dgomezpr@ecs.umass.edu
 *        Company:  UMASS
 *
 * =====================================================================================
 *  $Revision:: 234                                          $: Revision of last commit
 *  $Author:: daniel@win                                     $: Author of last commit
 *  $Date:: 2012-08-01 08:56:09 -0400 (Wed, 01 Aug 2012)     $: Date of last commit
 * =====================================================================================
 */
#ifndef __CONVERTDFG2TED_H__
#define __CONVERTDFG2TED_H__

#include <map>
using namespace std;

namespace ted {
	class TedMan;
	class ATedNode;
	class ETedNode;
}
using ted::TedMan;
using ted::TedNode;

namespace dfg {
	class DfgMan;
	class DfgNode;
}
using dfg::DfgMan;
using dfg::DfgNode;

namespace convert {

	class ConvertDfg2Ted {
	public:
		explicit ConvertDfg2Ted(DfgMan* dm, TedMan * tm) : _dMan(dm), _tMan(tm) {};
		~ConvertDfg2Ted(void) { _tMan = NULL; _dMan = NULL; }

		virtual void translate(void);
		ATedNode* translate(DfgNode* pNode);

		virtual void flatten(void);
		ATedNode* flatten(map<string,int>& hash_count, map<string,ATedNode*>& hash_name, DfgParents& parents, DfgNode* pNode);
	protected:
		virtual void translateDFS(void);
		virtual void translateLevels(void);

		DfgMan* _dMan;
		TedMan* _tMan;
		map <DfgNode *, ETedNode *> mVisited;
	};

}

#endif

