/*
 * =====================================================================================
 *
 *       Filename:  ConvertTed2DfgMinLatency.h
 *    Description:
 *        Created:  10/01/2012 08:35:48 PM
 *         Author:  Daniel f. Gomez-Prado (dgomezpr), dgomezpr@ecs.umass.edu
 *        Company:  UMASS
 *
 * =====================================================================================
 *  $Revision::                                              $: Revision of last commit
 *  $Author:: daniel@win                                     $: Author of last commit
 *  $Date:: 2012-07-07 17:43:11 -0400 (Sat, 07 Jul 2012)     $: Date of last commit
 * =====================================================================================
 */


#ifndef __CONVERTTED2DFGMINLATENCY_H__
#define __CONVERTTED2DFGMINLATENCY_H__

#include <string>
#include <map>
using namespace std;

#include "TedParents.h"

namespace ted {
	class TedMan;
	class TedNode;
}
namespace dfg {
	class DfgMan;
	class DfgNode;
}

#include "MapDfgNode.h"
#include "MapDfgPI.h"
#include "MapDfgTed.h"
#include "DfgChain.h"

#include "Environment.h"

namespace convert {

	using namespace dfg;
	using namespace ted;

	class ConvertTed2DfgMinLatency {
	public:
		explicit ConvertTed2DfgMinLatency(TedMan * tm, DfgMan* dm);
		~ConvertTed2DfgMinLatency(void) { _tMan = NULL; _dMan = NULL; _dOne = NULL; }

		void translate(void);
		void translate(TedNode* pNode);

		void respect_ntl_level(bool);
	private:

		DfgNode* getPIR(TedNode* pNode,int registers);
		pair<bool, bool> belong_to_chain(TedNode* node);
		DfgNode* resolve_mul_tree(DfgChain& muls2, wedge w, bool prevent_invertion);


		typedef map<TedNode*,DfgChain> MapChain;

		MapChain delayAdditive;
		MapChain delayMultiplicative;
		map<TedNode*,unsigned int> delayMap;

		bool _respect_ntl_level;

		ted::TedParents _parents;
		TedMan* _tMan;
		DfgMan* _dMan;
		DfgNode* _dOne;

		MapDfgPIR _piMapR;
		MapDfgNodeR _dMapR;
		MapDfgNodeP _dMapP;
		MapDfgTed _tMap;
	};

}
#endif

