/*
 * =====================================================================================
 *
 *       Filename:  DfgMap.h
 *    Description:
 *        Created:  10/01/2009 08:35:48 PM
 *         Author:  Daniel f. Gomez-Prado (dgomezpr), dgomezpr@ecs.umass.edu
 *        Company:  UMASS
 *
 * =====================================================================================
 *  $Revision:: 266                                          $: Revision of last commit
 *  $Author:: daniel@win                                     $: Author of last commit
 *  $Date:: 2012-09-08 22:39:11 -0400 (Sat, 08 Sep 2012)     $: Date of last commit
 * =====================================================================================
 */


#ifndef __MAPDFGNODE_H__
#define __MAPDFGNODE_H__

#include <string>
#include <cstring>
#include <map>

#include "DfgNode.h"
#include "DfgMan.h"
#include "ConvertMap.h"

namespace convert {
	using namespace dfg;
	using namespace std;

	using dfg::_DfgNode_MapOrder;

	class MapDfgNode : public ConvertMap<DfgNode*,DfgNode*,DfgMan*,DfgNode,_DfgNode_MapOrder> {
	public:
		explicit MapDfgNode(PManagerType ptr) : ConvertMap<DfgNode*,DfgNode*,DfgMan*,DfgNode,_DfgNode_MapOrder>(ptr) {};
		~MapDfgNode(void) {};

		void registrate(OuterKey, InnerKey, NodeType*);
		NodeType* get(OuterKey, InnerKey);
	};

	class MapDfgNodeR : public ConvertMap<DfgNode*,int,DfgMan*,DfgNode,_DfgNode_MapOrder> {
	public:
		explicit MapDfgNodeR(PManagerType ptr) : ConvertMap<DfgNode*,int,DfgMan*,DfgNode,_DfgNode_MapOrder>(ptr) {};
		~MapDfgNodeR(void) {};

		void registrate(OuterKey, InnerKey, NodeType*);
		NodeType* get(OuterKey, InnerKey);
	};

	class MapDfgNodeP : public ConvertMap<DfgNode*,unsigned int,DfgMan*,DfgNode,_DfgNode_MapOrder> {
	public:
		explicit MapDfgNodeP(PManagerType ptr) : ConvertMap<DfgNode*,unsigned int,DfgMan*,DfgNode,_DfgNode_MapOrder>(ptr) {};
		~MapDfgNodeP(void) {};

		void registrate(OuterKey, InnerKey, NodeType*);
		NodeType* get(OuterKey, InnerKey);
	private:

		NodeType* generate(Data&, InnerKey);
	};

}
#endif

