/*
 * =====================================================================================
 *
 *       Filename:  MapDfgPI.h
 *    Description:
 *        Created:  10/01/2009 08:35:48 PM
 *         Author:  Daniel f. Gomez-Prado (dgomezpr), dgomezpr@ecs.umass.edu
 *        Company:  UMASS
 *
 * =====================================================================================
 *  $Revision:: 255                                          $: Revision of last commit
 *  $Author:: daniel@win                                     $: Author of last commit
 *  $Date:: 2012-08-29 21:48:37 -0400 (Wed, 29 Aug 2012)     $: Date of last commit
 * =====================================================================================
 */


#ifndef __MAPDFGPI_H__
#define __MAPDFGPI_H__

#include <string>
using namespace std;

namespace dfg {
	class DfgMan;
	class DfgNode;
}

#include "ConvertMap.h"

namespace convert {

	using namespace dfg;

	// Maps the pair <node name,index power> to a DfgNode
	class MapDfgPI : public ConvertMap<string,unsigned int,DfgMan*,DfgNode> {
	public:
		explicit MapDfgPI(PManagerType ptr) : ConvertMap<string,unsigned int,DfgMan*,DfgNode>(ptr) {};
		~MapDfgPI(void) {};

		void registrate(OuterKey, InnerKey, NodeType*);
		NodeType* get(OuterKey, InnerKey);

	private:
		NodeType* generate(Data&, InnerKey);
	};

	// maps the pair <node name, register> to a DfgNode
	class MapDfgPIR : public ConvertMap<string,unsigned int,DfgMan*,DfgNode> {
	public:
		explicit MapDfgPIR(PManagerType ptr) : ConvertMap<string,unsigned int,DfgMan*,DfgNode>(ptr) {};
		~MapDfgPIR(void) {};

		void registrate(OuterKey, InnerKey, NodeType*);
		NodeType* get(OuterKey, InnerKey);

	private:
		NodeType* generate(Data&, InnerKey);
	};
}
#endif

