/*
 * =====================================================================================
 *
 *       Filename:  Bitwidth.inl
 *    Description:
 *        Created:  09/09/2009 10:12:54 AM
 *         Author:  Daniel f. Gomez-Prado (dgomezpr), dgomezpr@ecs.umass.edu
 *        Company:  UMASS
 *
 * =====================================================================================
 *  $Revision:: 224                                          $: Revision of last commit
 *  $Author:: daniel                                         $: Author of last commit
 *  $Date:: 2012-07-20 23:14:38 -0400 (Fri, 20 Jul 2012)     $: Date of last commit
 * =====================================================================================
 */

#ifndef INLINE
#define inline
#endif

inline string Integer::at(void) const { return Util::itoa(_integer); }
inline Integer* Integer::clone(void) const { return new Integer(*this); }
inline long Integer::norm(void) const { return _integer; }
inline unsigned int Integer::getSize(void) const { return _integer; }
//inline bool Integer::isInteger(void) const { return true; }
inline long double Integer::getMaxRange(void) const { return pow((double)2.0,(int)_integer)-1; }
//inline long double Integer::getMinRange(void) const { return -1*getMaxRange(); }

inline string FixedPoint::at(void) const { return Util::itoa(_integer)+","+Util::itoa(_fractional); }
inline FixedPoint* FixedPoint::clone(void) const { return new FixedPoint(*this); }
inline long FixedPoint::norm(void) const { return _integer+_fractional; }
inline unsigned int FixedPoint::getSize(void) const { return _fractional; }
//inline bool FixedPoint::isFixedPoint(void) const { return true; }

inline
long double FixedPoint::getMaxRange(void) const {
	return (long double) pow((double)2.0,(int)_integer) - (long double) pow((double)2.0,(int)(-1*_fractional));
}
//inline long double FixedPoint::getMinRange(void) const { return -1*getMaxRange(); }

inline
void FixedPoint::set(unsigned int word, unsigned int fraction) {
	_integer = word;
	_fractional = fraction;
};
