/*
 * =====================================================================================
 *
 *        Filename:  TedTypes.h
 *     Description:  TedNode class header
 *         Created:  04/17/2012 12:13:04 PM EDT
 *          Author:  Daniel Gomez-Prado
 *         Company:  UMASS
 *
 * =====================================================================================
 *  $Revision:: 215                                          $: Revision of last commit
 *  $Author:: daniel@win                                     $: Author of last commit
 *  $Date:: 2010-01-12 14:44:42 +0100(Tue, 12 Jan 2010)$: Date of last commit
 * =====================================================================================
 */

#ifndef __TEDTYPES_H__
#define __TEDTYPES_H__

#include <vector>
#include <set>
#include <map>
#include "limits.h"

namespace ted {

	using namespace std;
	class TedNode;
	class TedParents;

#if defined(_DEBUG)
	class TEDSet : public set<TedNode*> {
	private:
		void writeUpper(ofstream& ofile, const TedNode* pNode, const TedNode* pTouch, TedParents* parents, unsigned int index_up, const unsigned int index_stop);
		void writeLower(ofstream& ofile, const TedNode* pNode, const TedNode* pTouch, unsigned int index_down, const unsigned int index_stop);

		void writeTEDSet(ofstream& ofile, const TedNode* pTouch);
		void writeWindow(ofstream& ofile, const TedNode* pTouch, TedParents* parents, unsigned int link_parents, unsigned int link_children);
		void writeCone(ofstream& ofile, const TedNode* pTouch, TedParents* parents, unsigned int link_parents, unsigned int link_children);

	public:
		void visualize(void);
		void visualize(const TedNode* pTouch, TedParents* parents, unsigned int link_parents = 1, unsigned int link_children = 1);
		void visualizeUpperCone(const TedNode* pCone, TedParents* parents, unsigned int link_parents = UINT_MAX, unsigned int link_children = 1);

		void print2file(void);
		void print2fileDetailed(void);
	};
#else
	typedef set<TedNode*> TEDSet;
#endif
	typedef vector<TedNode*> TEDVector;

}

#endif
